#include <Arduino.h>
#include <ArduinoJson.h>
#include <WiFi.h>//
#include <HTTPClient.h>
#include <DFRobot_GDL.h>
#include "BMP.h"

const char *ssid = "dfrobotGuest";//wifi
const char *password = "dfrobot2020";//密码
const char *host = "";   //IPv4地址
String get_url = "http://api.bemfa.com/api/time/now/?type=1";
const char* host1 = "api.seniverse.com";
const int httpPort = 1000; 
String reqUserKey = "";   //心知天气私钥
String reqLocation = "chengdu"; //天气查询地址        
String reqUnit = "c";  

struct ncov_data{         
    long currentConfirmedCount;
    long currentConfirmedIncr;
    long confirmedCount;
    long curedCount;
    long seriousCount;
    long deadCount;
};

#define IR_DETEC_PIN  20
bool isWarn = false;
int l=0;

int16_t cpu_frequence;
int16_t cpu_usage;
int16_t ram_usage;
int16_t ram_avaliable;

WiFiClient client;

#define TFT_DC  1
#define TFT_CS  7
#define TFT_RST 6

DFRobot_ST7789_240x240_HW_SPI screen(/*dc=*/TFT_DC,/*cs=*/TFT_CS,/*rst=*/TFT_RST);
 

void setup() {
  Serial.begin(115200);
  pinMode(IR_DETEC_PIN, INPUT_PULLUP);
  screen.begin();
    testTriangles(COLOR_RGB565_YELLOW);
    testPrint();
    Serial.print("Connecting to ");
    Serial.println(ssid);
    WiFi.begin(ssid, password);
    while (WiFi.status() != WL_CONNECTED)
    {
        delay(500);
        Serial.print(".");
    }
    Serial.println("");
    Serial.println("WiFi connected");
    Serial.println("IP address: ");
    Serial.println(WiFi.localIP());

    Serial.println("");
    Serial.println("WiFi Conected!");

    if (!client.connect(host,80))
    {
        Serial.println("Connect host failed!");
        return;
    }
    Serial.println("host Conected!");
  
}
 
void loop() {

if (!digitalRead(IR_DETEC_PIN)) //
    {
        if (!isWarn) //
    {  l=l+1;}
    }

  
    if(l==0)
    {  
       
       screen.drawPIC(/*x=*/0,/*y=*/0,/*w=*/240,/*h=*/210,/*bitmap gImage_Bitmap=*/( uint8_t*)gImage_12);
      getTime();
 String reqRes = "/v3/weather/now.json?key=" + reqUserKey +
                  + "&location=" + reqLocation + 
                  "&language=en&unit=" +reqUnit;
 httpRequest(reqRes);
 l=1;
    }

if(l==2)
{
epidemicdata();
l=3;
}

    if(l==4)
    {  
parameter();
    }

    if(l>=5)
    {  
       screen.fillScreen(COLOR_RGB565_BLACK);
       screen.drawPIC(/*x=*/0,/*y=*/0,/*w=*/240,/*h=*/220,/*bitmap gImage_Bitmap=*/( uint8_t*)gImage_12);
      getTime();
 String reqRes = "/v3/weather/now.json?key=" + reqUserKey +
                  + "&location=" + reqLocation + 
                  "&language=en&unit=" +reqUnit;
 httpRequest(reqRes);
 l=1;
    }


  }




void getTime()
{
  HTTPClient http;  
    http.begin(get_url);  
    int httpCode = http.GET();             
    String response = http.getString();   
    Serial.println(response);           
    http.end();   

    int hour = response.substring(0,2).toInt();
    int minute = response.substring(3,5).toInt();
    int second = response.substring(6,8).toInt();
    Serial.println(hour); 
    Serial.println(minute); 
    Serial.println(second); 

  screen.setCursor(0, 220);
  screen.setTextSize(2);
  screen.println(hour);

    screen.setCursor(29, 220);
  screen.setTextSize(2);
  screen.println(":");

    screen.setCursor(44, 220);
  screen.setTextSize(2);
  screen.println(minute);

}

void httpRequest(String reqRes)
{
  WiFiClient client;
  String httpRequest = String("GET ") + reqRes + " HTTP/1.1\r\n" + 
                              "Host: " + host1 + "\r\n" + 
                              "Connection: close\r\n\r\n";
  Serial.println(""); 
  Serial.print("Connecting to "); Serial.print(host1);
  if (client.connect(host1, 80)){
    Serial.println(" Success!");
    client.print(httpRequest);
    Serial.println("Sending request: ");
    Serial.println(httpRequest);  
    String status_response = client.readStringUntil('\n');
    Serial.print("status_response: ");
    Serial.println(status_response);
    if (client.find("\r\n\r\n")) {
      Serial.println("Found Header End. Start Parsing.");
    }
    parseInfo(client); 
  } else {
    Serial.println(" connection failed!");
  }  
  client.stop(); 
}


void parseInfo(WiFiClient client){
  const size_t capacity = JSON_ARRAY_SIZE(1) + JSON_OBJECT_SIZE(1) + 2*JSON_OBJECT_SIZE(3) + JSON_OBJECT_SIZE(6) + 230;
  DynamicJsonDocument doc(capacity);
  
  deserializeJson(doc, client);
  
  JsonObject results_0 = doc["results"][0];
  
  JsonObject results_0_now = results_0["now"];
  const char* results_0_now_text = results_0_now["text"]; 
  const char* results_0_now_code = results_0_now["code"]; 
  const char* results_0_now_temperature = results_0_now["temperature"]; 
  
  const char* results_0_last_update = results_0["last_update"]; 
 
  String results_0_now_text_str = results_0_now["text"].as<String>(); 
  int results_0_now_code_int = results_0_now["code"].as<int>(); 
  int results_0_now_temperature_int = results_0_now["temperature"].as<int>(); 
  
  String results_0_last_update_str = results_0["last_update"].as<String>();   
 
  Serial.println(F("======Weahter Now======="));
  Serial.print(F("Weather Now: "));
  Serial.print(results_0_now_text_str);
  Serial.print(F(" "));
  Serial.println(results_0_now_code_int);
  Serial.print(F("Temperature: "));
  Serial.println(results_0_now_temperature_int);
  Serial.print(F("Last Update: "));
  Serial.println(results_0_last_update_str);
  Serial.println(F("========================"));
  
  screen.setCursor(100, 223);
  screen.setTextSize(2);
  screen.println(results_0_now_text_str);

  screen.setCursor(214, 223);
  screen.setTextSize(2);
  screen.println(results_0_now_temperature_int);

}


void parameter()
{
  String getUrl = "/sse";
    client.print(String("GET ") + getUrl + " HTTP/1.1\r\n" + "Content-Type=application/json;charset=utf-8\r\n" + "Host: " + host + "\r\n" + "User-Agent=ESP32\r\n" + "Connection: close\r\n\r\n");
    Serial.println("Get send");

    delay(10);

    char endOfHeaders[] = "\n\n";
    bool ok = client.find(endOfHeaders);
    if (!ok)
    {
        Serial.println("No response or invalid response!");
    }
    Serial.println("Skip headers");

    String line = "";

    line += client.readStringUntil('\n');

    Serial.println("Content:");
    Serial.println(line);

    int16_t dataStart = 0;
    int16_t dataEnd = 0;
    String dataStr;

    char cpuFreq[] = "CPU frequence";
    dataStart = line.indexOf(cpuFreq) + strlen(cpuFreq);
    dataEnd = line.indexOf("MHz", dataStart);
    dataStr = line.substring(dataStart, dataEnd);
    cpu_frequence = dataStr.toInt();

    char cpuUsage[] = "CPU usage";
    dataStart = line.indexOf(cpuUsage) + strlen(cpuUsage);
    dataEnd = line.indexOf("%", dataStart);
    dataStr = line.substring(dataStart, dataEnd);
    cpu_usage = dataStr.toInt();

    char ramUsage[] = "RAM usage";
    dataStart = line.indexOf(ramUsage) + strlen(ramUsage);
    dataEnd = line.indexOf("%", dataStart);
    dataStr = line.substring(dataStart, dataEnd);
    ram_usage = dataStr.toInt();

    char ramAvali[] = "RAM avaliable";
    dataStart = line.indexOf(ramAvali) + strlen(ramAvali);
    dataEnd = line.indexOf("MB", dataStart);
    dataStr = line.substring(dataStart, dataEnd);
    ram_avaliable = dataStr.toInt();

    Serial.print("CPU frequency :");
    Serial.println(cpu_frequence);
    Serial.print("CPU usage :");
    Serial.println(cpu_usage);
    Serial.print("Memory usage :");
    Serial.println(ram_usage);
    Serial.print("Available memory :");
    Serial.println(ram_avaliable);

   int16_t color = 0x00FF; 
  screen.fillScreen(COLOR_RGB565_BLACK);
  screen.setTextSize(3);
  
  screen.setTextColor(color+=0x3000);
  screen.setCursor(0, 0);
  screen.println("CPU frequeny:");
  screen.setCursor(0, 30);
  screen.println(cpu_frequence);

  screen.setTextColor(color+=0x3000);
  screen.setCursor(0, 65);
  screen.println("CPU usage:");
  screen.setCursor(195, 65);
  screen.println(cpu_usage);

  screen.setTextColor(color+=0x3000);
  screen.setCursor(0, 100);
  screen.println("Memory usage:");
  screen.setCursor(0, 130);
  screen.println(ram_usage);

 screen.setTextColor(color+=0x3000);
  screen.setCursor(0, 165);
  screen.println("Availabl memy:");
  screen.setCursor(0, 195);
  screen.println(ram_avaliable);
  
    delay(1000);
}


void epidemicdata() {
  HTTPClient http;
 
  http.begin("https://lab.isaaclin.cn/nCoV/api/overall");
  int httpCode = http.GET();   
  if (httpCode > 0) 
  {
    if (httpCode == HTTP_CODE_OK) 
    {
      String payload = http.getString(); 
      Serial.println(payload);         
      
      ncov_data China_data;             
      ncov_data World_data;             
      DynamicJsonDocument doc(1000);    
      deserializeJson(doc, payload);    
      JsonObject results_0 = doc["results"][0];
 
      China_data.currentConfirmedCount = results_0["currentConfirmedCount"].as<int>();
      China_data.confirmedCount = results_0["confirmedCount"].as<int>();
      China_data.curedCount = results_0["curedCount"].as<int>();
      China_data.deadCount = results_0["deadCount"].as<int>();
      China_data.seriousCount = results_0["seriousCount"].as<int>();
 
      World_data.currentConfirmedCount = results_0["globalStatistics"]["currentConfirmedCount"].as<long>();
      World_data.confirmedCount = results_0["globalStatistics"]["confirmedCount"].as<long>();
      World_data.curedCount = results_0["globalStatistics"]["curedCount"].as<long>();
      World_data.deadCount = results_0["globalStatistics"]["deadCount"].as<long>();
 
      Serial.println("");
      Serial.println("----------------国内疫情---------------");
      Serial.print("现存确诊: ");Serial.println(China_data.currentConfirmedCount);
      Serial.print("累计确诊: ");Serial.println(China_data.confirmedCount);
      Serial.print("累计治愈: ");Serial.println(China_data.curedCount);
      Serial.print("现存无症: ");Serial.println(China_data.seriousCount);
      Serial.print("累计死亡: ");Serial.println(China_data.deadCount);
      Serial.println("----------------国外疫情---------------");
      Serial.print("现存确诊: ");Serial.println(World_data.currentConfirmedCount);
      Serial.print("累计确诊: ");Serial.println(World_data.confirmedCount);
      Serial.print("累计治愈: ");Serial.println(World_data.curedCount);
      Serial.print("累计死亡: ");Serial.println(World_data.deadCount);

 int16_t color = 0x00FF; 
  screen.fillScreen(COLOR_RGB565_BLACK);
  screen.setTextSize(2);
  
  screen.setCursor(80,0);
  screen.println("domestic");
  screen.setCursor(0,20);
  screen.println("Diagnosis:");
  screen.setCursor(0, 40);
  screen.println("Cumulative:");
  screen.setCursor(0, 60);
  screen.println("Cure:");
  screen.setCursor(0,80);
  screen.println("Asymptomatic:");
  screen.setCursor(0,100);
  screen.println("Death:");
  
  screen.setCursor(80,140);
  screen.println("abroad");
  screen.setCursor(0,160);
  screen.println("Diagnosis:");
  screen.setCursor(0,180);
  screen.println("Cumulative:");
  screen.setCursor(0,200);
  screen.println("Cure:");
  screen.setCursor(0,220);
  screen.println("Death:");

  screen.setTextColor(color+=0x3000);
  screen.setCursor(121,20);
  screen.println(China_data.currentConfirmedCount);
  screen.setCursor(130, 40);
  screen.println(China_data.confirmedCount);
  screen.setCursor(60, 60);
  screen.println(China_data.curedCount);
  screen.setCursor(152, 80);
  screen.println(China_data.seriousCount);
  screen.setCursor(70,100);
  screen.println(China_data.deadCount);
  
  screen.setCursor(121,160);
  screen.println(World_data.currentConfirmedCount);
  screen.setCursor(130,180);
  screen.println(World_data.confirmedCount);
  screen.setCursor(61,200);
  screen.println(World_data.curedCount);
  screen.setCursor(70,220);
  screen.println(World_data.deadCount);
  
      
    }
  }
  else
  { 
    Serial.printf("[HTTP] GET... failed, error: %s\n", http.errorToString(httpCode).c_str());
  }
  http.end(); 
 
  delay(1000);
}


//...............................................
void testTriangles(uint16_t color){
  screen.fillScreen(COLOR_RGB565_BLACK);

  for (int16_t i=0; i <=screen.width(); i+=24)

    screen.drawTriangle(/*x0=*/i,/*y0=*/0,/*x1=*/0,/*y1=*/screen.height()-i,/*x2=*/screen.width()-i,/*y2=*/screen.height(), /*color=*/color);

  for (int16_t i=0; i <screen.width(); i+=24)
    screen.drawTriangle(screen.width(),i*4/3,0,screen.height()-i*4/3,i,0, color);

  for (int16_t i=0; i <screen.width(); i+=24)
    screen.drawTriangle(screen.width(),i*4/3,i,0,screen.width()-i,screen.height(), color);

  color = COLOR_RGB565_RED;
  for (int16_t i=0; i <=screen.width(); i+=24)
 
    screen.fillTriangle(/*x0=*/i,/*y0=*/0,/*x1=*/0,/*y1=*/screen.height()-i,/*x2=*/screen.width()-i,/*y2=*/screen.height(), /*color=*/color+=100);

  for (int16_t i=0; i <screen.width(); i+=24)
    screen.fillTriangle(screen.width(),i*4/3,0,screen.height()-i*4/3,i,0, color+=100);

  for (int16_t i=0; i <screen.width(); i+=24)
    screen.fillTriangle(screen.width(),i*4/3,i,0,screen.width()-i,screen.height(), color+=100);
}

void testPrint()
{
  int16_t color = 0x00FF;
  screen.setTextWrap(false);
  screen.fillScreen(COLOR_RGB565_BLACK);
  screen.setCursor(0, 50);
  screen.setTextColor(color+=0x3000);
  screen.setTextSize(0);
  screen.println("Hello World!");

  screen.setTextColor(color+=0x3000);
  screen.setTextSize(1);
  screen.println("Hello World!");

  screen.setTextColor(color+=0x3000);
  screen.setTextSize(2);
  screen.println("Hello World!");

  screen.setTextColor(color+=0x3000);
  screen.setTextSize(3);
  screen.println("Hello World!");

  screen.setTextColor(color+=0x3000);
  screen.setTextSize(4);
  screen.println("Hello!");
  screen.setTextSize(5);
  screen.print("Hello!");
  delay(1000);
  screen.setCursor(0, 0);
  screen.fillScreen(COLOR_RGB565_BLACK);
  screen.setTextSize(2);
  screen.setTextColor(color+=0x3000);
  screen.print("a = ");

  screen.setTextColor(color+=0x3000);
  int a = 1234;
  screen.println(a, 1);
  screen.setTextColor(color+=0x3000);
  screen.print(8675309, HEX);
  screen.println("this is HEX!");
  screen.println("");

  screen.setTextColor(color+=0x0F00);
  screen.println("running for: ");
  screen.setTextColor(color+=0x0F00);
  screen.print(millis());
  screen.setTextColor(color+=0x0F00);
  screen.println("/1000 seconds.");

  char *text = "Hi DFRobot!";
  screen.setTextColor(color+=0x0F00);
  screen.setTextWrap(true);
  screen.setTextSize(3);
  screen.println(text);
  //screen.setFonts((const gdl_Font_t *)SIMKAIFont18ptBitmaps);
  screen.println(text);
  delay(1000);
}
 
